
// inset all elements from HTML doc
const form = document.getElementById('form');
const username = document.getElementById('userName');
const password = document.getElementById('password');
const repeatPassword = document.getElementById('repeatPassword');
const firstName = document.getElementById('firstName');
const lastName = document.getElementById('lastName');
const address = document.getElementById('address');
const optAddress = document.getElementById('optAddress');
const city = document.getElementById('city');
const state = document.getElementById('state');
const zip = document.getElementById('zip');
const phone = document.getElementById('phone');
const email = document.getElementById('email');
const birthday = document.getElementById('birthday');
const popup = document.getElementById('errorMessage');
const submit = document.getElementById('submit');

// this function shows the error popup with text what the user needs to do
function showError(text) {
    popup.style.visibility = "visible";
    popup.textContent = text;
}

// this function hides the error popup and resets the content
function onClick() {
    popup.style.visibility = "hidden";
    popup.textContent = "";
}

// this next several functions are triggered onblur for each input and check for validation

username.addEventListener('blur', (e) => {
    if(username.value === '') {
        username.style.border = "solid red";
        showError("Please enter a username!");
    }
    else if (6 > username.value.length || 50 < username.value.length) {
        username.style.border = "solid red";
        showError("Username must be between 50 and 6 characters.")
    }
    else {
        username.style.border = "solid green";
    }

})

password.addEventListener('blur', (e) => {
    const validate = /\S/
    if (password.value === '') {
        password.style.border = "solid red";
        showError("Please enter a password!")
    }
    else if (8 > password.value.length || 50 < password.value.length) {
        password.style.border = "solid red";
        showError("Password must be between 8 and 50 characters.")
    }
    else if(!(validate.test(password.value))) {
        password.style.border = "solid red";
        showError("Password must contain 1 capital, 1 lowercase, 1 digit, and 1 special character")
    }
    else {
        password.style.border = "solid green";
    }
})

repeatPassword.addEventListener('blur', (e) => {
    if (repeatPassword.value === '') {
        repeatPassword.style.border = "solid red";
        showError("Please repeat your password!")
    }
    else if (repeatPassword.value !== password.value) {
        showError("Passwords do not match!")
        repeatPassword.style.border = "solid red";
    }
    else {
        repeatPassword.style.border = "solid green";
    }
})

firstName.addEventListener('blur', (e) => {
    if (firstName.value === '') {
        showError('First name is required!')
        firstName.style.border = "solid red";
    }
    else if (firstName.value.length > 50) {
        firstName.style.border = "solid red";
        showError("First name must be under 50 characters.")
    }
    else {
        firstName.style.border = "solid green";
    }
})

lastName.addEventListener('blur', (e) => {
    if (lastName.value === '') {
        showError('Last name is required!')
        lastName.style.border = "solid red";
    }
    else if (lastName.value.length > 50) {
        showError("Last name must be under 50 characters.")
        lastName.style.border = "solid green";
    }
    else {
        lastName.style.border = "solid green";
    }
})

address.addEventListener('blur', (e) => {
    if (address.value === '') {
        showError("Address is required!")
        address.style.border = "solid red";
    }
    else if (address.value.length > 100) {
        address.style.border = "solid red";
        showError("Address must be under 100 characters.")
    }
    else {
        address.style.border = "solid green";
    }
})

optAddress.addEventListener('blur', (e) => {
    if (username.value.length > 100) {
        showError("Address 2 must be under 100 characters.");
        optAddress.style.border = "solid red";
    }
    else {
        optAddress.style.border = "solid green";
    }
})

city.addEventListener('blur', (e) => {
    if (city.value === '') {
        showError("City is required!");
        city.style.border = "solid red";
    }
    else if (city.value.length > 50) {
        city.style.border = "solid red";
        showError("City must be under 50 characters.");
    }
    else {
        city.style.border = "solid green";
    }
})

state.addEventListener('blur', (e) => {
    if (state.value === '') {
        showError("State is required!");
        state.style.border = "solid red";
    }
    else if (state.value.length > 52) {
        showError("State must be under 52 characters.")
        state.style.border = "solid red";
    }
    else {
        state.style.border = "solid green";
    }
})

zip.addEventListener('blur', (e) => {
    if (zip.value === '') {
        showError("Zip code is required!")
        zip.style.border = "solid red";
    }
    else if (zip.value.length > 10 || zip.value.length < 5) {
        zip.style.border = "solid red";
        showError("Zip code must be between 5 and 10 characters")
    }
    else {
        zip.style.border = "solid green";
    }
})

phone.addEventListener('blur', (e) => {
    if (phone.value === '') {
        phone.style.border = "solid red";
        showError("Phone number is required!");
    }
    else if (phone.value.length > 12) {
        phone.style.border = "solid red";
        showError("Phone number must be under 12 characters.")
    }
    else {
        phone.style.border = "solid green";
    }
})

email.addEventListener('blur', (e) => {
    const validate = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/;
    if (email.value === '') {
        email.style.border = "solid red";
        showError("Email is required!");
    }
    else if (!(validate.test(email.value))) {
        email.style.border = "solid red";
        showError("Incorrect email format!")
    }
    else {
        email.style.border = "solid green";
    }
})

birthday.addEventListener('blur', (e) => {
    if (birthday.value === '') {
        showError("Birthday is required!");
        birthday.style.border = "solid red";
    }
    else {
        birthday.style.border = "solid green";
    }
})

